import QtQuick 1.1
import qb.components 1.0

/*
 * Tile for showing boiler parameters like boiler setpoint, pressure etc. on 
 * screen. Requires BoilerstatusApp.qml for data presentation.
 * 
 * (People at the Eneco forum have been asking for this for ages, it's here
 * just to nag the living daylights out of them ;-) ).
 *
 * 20170117: marcelr, first draft
 *
 */

Tile {
    id: boilerStatusTile
    
    property bool dimState: screenStateController.dimmedColors
    property bool haveOT: app.haveOpenTherm

	/*
	  
	  onClicked: {
	  app.radarimagesSmallurl ="http://toon/";  //resetimage
	  app.radarimagesSmallurl ="http://api.buienradar.nl/image/1.0/RadarMapNL?w=180&h=180";
	  if (app.buienradarDetailsScreen)
	  app.buienradarDetailsScreen.show();
	  }
	  
	*/
	
	/*
	  Image {
	  id: weatherTileIconzz
	  source: app.icoonimageDim
	  anchors {
	  baseline: parent.top
	  baselineOffset: 80
	  horizontalCenter: parent.horizontalCenter
	  //			verticalCenter: parent.verticalCenter
	  }
	  cache: false
	  visible: dimState
	  }
	*/
	
	Text {  // r1 c1
	    id: boilerStatusTileRoomTempSetpoint
	    
	    text: i18n.number( Number( app.roomTempSetpoint ), 1 )
	    anchors {
		baseline: parent.top
		baselineOffset: 34
		right: parent.right
		rightMargin: 146
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 18
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
	}
	
	Text { // r1 c2
	    id: boilerStatusTileRoomTemp
	    
	    text: i18n.number( Number( app.roomTemp ), 1 )
	    anchors {
		baseline: parent.top
		baselineOffset: 34
		right: parent.right
		rightMargin: 35
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 18
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
	} 
	
	Text { // r2 c1
	    id: boilerStatusTileBoilerSetpoint
	    
	    text: i18n.number( Number( app.boilerSetpoint ), 1 )
	    anchors {
		baseline: parent.top
		baselineOffset: 61
		right: parent.right
		rightMargin: 146
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 18
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
	}
	
	Text { // r2 c2
	    id: boilerStatusTileBoilerOutTemp
	    
	    text: i18n.number( Number( app.boilerOutTemp ), 1 )
	    anchors {
		baseline: parent.top
		baselineOffset: 61
		right: parent.right
		rightMargin: 35
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 18
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
	}
	
	Text { // r3 c1
	    id: boilerStatusTileOutsideTemp
	    
	    text: i18n.number( Number( app.outsideTemp ), 1 )
	    anchors {
		baseline: parent.top
		baselineOffset: 88
		right: parent.right
		rightMargin: 146
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 18
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
	}
	
	Text { // r3 c2
	    id: boilerStatusTileBoilerInTemp
	    
	    text: i18n.number( Number( app.boilerInTemp ), 1 )
	    anchors {
		baseline: parent.top
		baselineOffset: 88
		right: parent.right
		rightMargin: 35
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 18
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
	}
	
	
	Text { // r4 c1
	    id: boilerStatusTileDHWTempSetpoint
	    
	    text: i18n.number( Number( app.maxDHWSetpoint ), 1 )
	    anchors {
		baseline: parent.top
		baselineOffset: 115
		right: parent.right
		rightMargin: 146
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 18
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
	}
	
	Text { // r4 c2
	    id: boilerStatusTileDHWTemp
	    
	    text: i18n.number( Number( app.dhwTemp ), 1 )
	    anchors {
		baseline: parent.top
		baselineOffset: 115
		right: parent.right
		rightMargin: 35
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 18
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
	}


	Text { // r5 c1
	    id: boilerStatusTileRelModLevel
	    
	    text: i18n.number( Number( app.relModLevel ), 1 )
	    anchors {
		baseline: parent.top
		baselineOffset: 142
		right: parent.right
		rightMargin: 146
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 18
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
	}
	
	Text { // r5 c2
	    id: boilerStatusTileBoilerPressure
	    
	    text: i18n.number( Number( app.boilerPressure ), 1 )
	    anchors {
		baseline: parent.top
		baselineOffset: 142
		right: parent.right
		rightMargin: 35
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 18
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
	}
	
	
	/*
	 * UNITS
	 */
	
	Text {
	    id: boilerStatusTileRoomTempSetpointUnit
	    
	    text: "°C"
	    anchors {
		baseline: parent.top
		baselineOffset: 34
		left: parent.left
		leftMargin: 87
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 14
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
	}
	
	
	Text {
	    id: boilerStatusTileRoomTempUnit
	    
	    text: "°C"
	    anchors {
		baseline: parent.top
		baselineOffset: 34
		left: parent.left
		leftMargin: 198
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 14
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
	}
	
	
	Text {
	    id: boilerStatusTileBoilerSetpointUnit
	    
	    text: "°C"
	    anchors {
		baseline: parent.top
		baselineOffset: 61
		left: parent.left
		leftMargin: 87
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 14
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
	}
	
	
	Text {
	    id: boilerStatusTileBoilerOutTempUnit
	    
	    text: "°C"
	    anchors {
		baseline: parent.top
		baselineOffset: 61
		left: parent.left
		leftMargin: 198
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 14
	    }
	    visible: haveOT && (!dimState )
	    color: colors.clockTileColor
	}
	
	
	Text {
	    id: boilerStatusTileOutsideTempUnit
	    
	    text: "°C"
	    anchors {
		baseline: parent.top
		baselineOffset: 88
		left: parent.left
		leftMargin: 87
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 14
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
	}
	

	Text {
	    id: boilerStatusTileBoilerInTempUnit
	    
	    text: "°C"
	    anchors {
		baseline: parent.top
		baselineOffset: 88
		left: parent.left
		leftMargin: 198
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 14
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
   }


	Text {
	    id: boilerStatusTileDhwTempSetpointUnit
	    
	    text: "°C"
	    anchors {
		baseline: parent.top
		baselineOffset: 115
		left: parent.left
		leftMargin: 87
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 14
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
	}
	

	Text {
	    id: boilerStatusTileDhwTempUnit
	    
	    text: "°C"
	    anchors {
		baseline: parent.top
		baselineOffset: 115
		left: parent.left
		leftMargin: 198
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 14
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
   }
		
	
	Text {
	    id: boilerStatusTileRelModLevelUnit
	    
	    text: "%"
	    anchors {
		baseline: parent.top
		baselineOffset: 142
		left: parent.left
		leftMargin: 87
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 14
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
	}
	
	
	Text {
	    id: boilerStatusTileBoilerPressureUnit
	    
	    text: "bar"
	    anchors {
		baseline: parent.top
		baselineOffset: 142
		left: parent.left
		leftMargin: 198
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 14
	    }
	    color: colors.clockTileColor
	    visible: haveOT && (!dimState )
	}
	
/* ICONS */

	Image {
	    id: boilerStatusTileRoomTempSetpointIcon
	    source: "./drawables/RoomTempSetpointIcon.png"
	    anchors {
		baseline: parent.top
		baselineOffset: 15
		left: parent.left
		leftMargin: 10
	    }
	    cache: false
	    visible: haveOT && (!dimState )
	}
	
	Image {
	    id: boilerStatusTileRoomTempIcon
	    source: "./drawables/RoomTempIcon.png"
	    anchors {
		baseline: parent.top
		baselineOffset: 15
		left: parent.left
		leftMargin: 123
	    }
	    cache: false
	    visible: haveOT && (!dimState )
	}
	
	Image {
	    id: boilerStatusTileBoilerTempOutSetpointIcon
	    source: "./drawables/BoilerOutTempSetpointIcon.png"
	    anchors {
		baseline: parent.top
		baselineOffset: 42
		left: parent.left
		leftMargin: 10
	    }
	    cache: false
	    visible: haveOT && (!dimState )
	}
	
	Image {
	    id: boilerStatusTileBoilerTempOutIcon
	    source: "./drawables/BoilerTempOutIcon.png"
	    anchors {
		baseline: parent.top
		baselineOffset: 42
		left: parent.left
		leftMargin: 126
	    }
	    cache: false
	    visible: haveOT && (!dimState )
	}


	Image {
	    id: boilerStatusTileOutsideTempIcon
	    source: "./drawables/OutsideTempIcon.png"
	    anchors {
		baseline: parent.top
		baselineOffset: 69
		left: parent.left
		leftMargin: 10
	    }
	    cache: false
	    visible: haveOT && (!dimState )
	}
	
	
	Image {
	    id: boilerStatusTileBoilerTempInIcon
	    source: "./drawables/BoilerTempInIcon.png"
	    anchors {
		baseline: parent.top
		baselineOffset: 69
		left: parent.left
		leftMargin: 126
	    }
	    cache: false
	    visible: haveOT && (!dimState )
	}


	Image {
	    id: boilerStatusTileDHWTempSetpointIcon
	    source: "./drawables/DHWTempSetpointIcon.png"
	    anchors {
		baseline: parent.top
		baselineOffset: 96 
		left: parent.left
		leftMargin: 10
	    }
	    cache: false
	    visible: haveOT && (!dimState )
	}
	
	Image {
	    id: boilerStatusTileDHWTempIcon
	    source: "./drawables/DHWTempIcon.png"
	    anchors {
		baseline: parent.top
		baselineOffset: 96
		left: parent.left
		leftMargin: 126
	    }
	    cache: false
	    visible: haveOT && (!dimState )
	}

	
	Image {
	    id: boilerStatusTileModulationLevelIcon
	    source: "./drawables/flameSmall.png"
	    anchors {
		baseline: parent.top
		baselineOffset: 123
		left: parent.left
		leftMargin: 15
	    }
	    cache: false
	    visible: haveOT && (!dimState )
	}
	
	Image {
	    id: boilerStatusTileBoilerPressureIcon
	    source: "./drawables/BoilerPressureIcon.png"
	    anchors {
		baseline: parent.top
		baselineOffset: 123
		left: parent.left
		leftMargin: 126
	    }
	    cache: false
	    visible: haveOT && (!dimState )
	}


	Image {
		id: boilerStatusTileDimstateImage
		source: "../thermostat/drawables/flameLarge_dim.png"
		anchors {
			baseline: parent.top
			baselineOffset: 80
			horizontalCenter: parent.horizontalCenter
		}
		cache: false
       	visible: haveOT && dimState
	}

	Text {
		id: boilerStatusTileDimstateText
		text: i18n.number( Number( app.relModLevel ), 1 ) + " %"
		anchors {
			baseline: parent.top
			baselineOffset: 55
			horizontalCenter: parent.horizontalCenter
		}
		font {
			family: qfont.regular.name
			pixelSize: 50
		}
		color: colors.waTileTextColor
       	visible: haveOT && dimState
	}
















	
	Text {
	    id: noOTMessage
	    text: "Geen OpenTherm support.\nDeze tegel is nu\nvrij nutteloos."
/* 
 * Bugs, bugs, bugs; once connected to an Opentherm boiler, the boiler module
 * keeps spitting out the last known OT data, even when the boiler is 
 * disconnected.
 * This reduces the functionality of this text to a REAL bang-bang controlled 
 * boiler. OT signal dropout will not show, just the displayed numbers won't
 * change any more.
 */
	    anchors {
		baseline: parent.top
		baselineOffset: 56
		horizontalCenter: parent.horizontalCenter
		verticalCenter: parent.verticalCenter
	    }
	    font {
		family: qfont.regular.name
		pixelSize: 18
	    }
	    color: colors.clockTileColor
	    visible: !haveOT
	}

}
